---
title: float
slug: Web/CSS/float
tags:
  - CSS
  - CSS Positioning
  - CSS Property
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>float</code></strong> CSS property places an element on the left or right side of its container, allowing text and inline elements to wrap around it.</span> The element is removed from the normal flow of the page, though still remaining a part of the flow (in contrast to <a href="/en-US/docs/Web/CSS/position#Absolute_positioning">absolute positioning</a>).</p>

<div>{{EmbedInteractiveExample("pages/css/float.html")}}</div>

<p>A <em>floating element</em> is one where the computed value of <code>float</code> is not <code>none</code>.</p>

<p>As <code>float</code> implies the use of the block layout, it modifies the computed value of the {{cssxref("display")}} values, in some cases:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specified value</th>
   <th scope="col">Computed value</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>inline</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>inline-block</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>inline-table</code></td>
   <td><code>table</code></td>
  </tr>
  <tr>
   <td><code>table-row</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-row-group</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-column</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-column-group</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-cell</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-caption</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-header-group</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>table-footer-group</code></td>
   <td><code>block</code></td>
  </tr>
  <tr>
   <td><code>inline-flex</code></td>
   <td><code>flex</code></td>
  </tr>
  <tr>
   <td><code>inline-grid</code></td>
   <td><code>grid</code></td>
  </tr>
  <tr>
   <td><em>other</em></td>
   <td><em>unchanged</em></td>
  </tr>
 </tbody>
</table>

<div class="note"><strong>Note: </strong>If you're referring to this property from JavaScript as a member of the {{domxref("HTMLElement.style")}} object, modern browsers support <code>float</code>, but in older browsers you have to spell it as <code>cssFloat</code>, with Internet Explorer versions 8 and older using <code>styleFloat</code>. This was an exception to the rule, that the name of the DOM member is the camel-case name of the dash-separated CSS name (due to the fact that "float" is a reserved word in JavaScript, as seen in the need to escape "class" as "className" and escape &lt;label&gt;'s "for" as "htmlFor").</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
float: left;
float: right;
float: none;
float: inline-start;
float: inline-end;

/* Global values */
float: inherit;
float: initial;
float: unset;
</pre>

<p>The <code>float</code> property is specified as a single keyword, chosen from the list of values below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>left</code></dt>
 <dd>The element must float on the left side of its containing block.</dd>
 <dt><code>right</code></dt>
 <dd>The element must float on the right side of its containing block.</dd>
 <dt><code>none</code></dt>
 <dd>The element must not float.</dd>
 <dt><code>inline-start</code></dt>
 <dd>The element must float on the start side of its containing block. That is the left side with <code>ltr</code> scripts, and the right side with <code>rtl</code> scripts.</dd>
 <dt><code>inline-end</code></dt>
 <dd>The element must float on the end side of its containing block. That is the right side with <code>ltr</code> scripts, and the left side with <code>rtl</code> scripts.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="How_floated_elements_are_positioned">How floated elements are positioned</h3>

<p>As mentioned above, when an element is floated, it is taken out of the normal flow of the document (though still remaining part of it). It is shifted to the left, or right, until it touches the edge of its containing box, <em>or another floated element</em>.</p>

<p>In this example, there are three colored squares. Two are floated left, and one is floated right. Note that the second "left" square is placed to the right of the first. Additional squares would continue to stack to the right, until they filled the containing box, after which they would wrap to the next line.</p>

<p>A floated element is at least as tall as it's tallest nested floated children. We gave the parent <code>width: 100%</code> and floated it to ensure it is tall enough to encompass it's floated children, and to make sure it takes up the width of the parent so we don't have to clear it's adjacent sibling.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;section&gt;
  &lt;div class="left"&gt;1&lt;/div&gt;
  &lt;div class="left"&gt;2&lt;/div&gt;
  &lt;div class="right"&gt;3&lt;/div&gt;
  &lt;p&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit.
     Morbi tristique sapien ac erat tincidunt, sit amet dignissim
     lectus vulputate. Donec id iaculis velit. Aliquam vel
     malesuada erat. Praesent non magna ac massa aliquet tincidunt
     vel in massa. Phasellus feugiat est vel leo finibus congue.&lt;/p&gt;
&lt;/section&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">section {
  border: 1px solid blue;
  width: 100%;
  float: left;
}

div {
  margin: 5px;
  width: 50px;
  height: 150px;
}

.left {
  float: left;
  background: pink;
}

.right {
  float: right;
  background: cyan;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('How_floated_elements_are_positioned','400','180')}}</p>

<h3 id="Clearing_floats">Clearing floats</h3>

<p>Sometimes you may want to force an item to move below any floated elements. For instance, you may want paragraphs to remain adjacent to floats, but force headings to be on their own line. See {{cssxref("clear")}} for examples.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS Logical Properties', '#float-clear', 'float and clear')}}</td>
   <td>{{Spec2('CSS Logical Properties')}}</td>
   <td>Adds the values <code>inline-start</code> and <code>inline-end</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'visuren.html#float-position', 'float')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#float', 'float')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("css.properties.float")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/block_formatting_context">Block formatting context</a></li>
 <li>Use {{cssxref("clear")}} to force an item to move below a floated element.</li>
</ul>
